#!/usr/bin/env ts-node
"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
}
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
}
Object.defineProperty(exports, "__esModule", { value: true });
var commander = __importStar(require("commander"));
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
var node_fetch_1 = __importDefault(require("node-fetch"));
var form_data_1 = __importDefault(require("form-data"));
var zipper = require("zip-local");
var program = new commander.Command();
program
    .version('1.0.0')
    .option('-p, --path <path>', 'path of file or directory')
    .option('-e, --expires [string]', 'number follow d for days, w for weeks, m for months, y for years');
program.parse(process.argv);
if (program['path']) {
    if (fs_1.default.existsSync(program['path'])) {
        var stats = fs_1.default.statSync(program['path']);
        var formData = new form_data_1.default();
        var bufferContent = undefined;
        if (stats.isDirectory()) {
            var folderPath = program['path'].split(path_1.default.sep);
            var folderName = folderPath[folderPath.length - 2];
            bufferContent = zipper.sync.zip(program['path']).compress().memory();
            formData.append('file', bufferContent, {
                filename: folderName + '.zip',
                contentType: 'application/zip'
            });
        }
        else {
            bufferContent = fs_1.default.createReadStream(program['path']);
            formData.append('file', bufferContent);
        }
        var params = {
            'method': 'POST',
            'body': formData
        };
        var url = 'https://file.io/' + (program['expires'] ? ('?expires=' + program['expires']) : '');
        node_fetch_1.default(url, params)
            .then(function (res) { return res.json(); })
            .then(function (data) {
            console.log(data.link);
        })
            .catch(console.error);
    }
    else {
        console.log('path not exist', program['path']);
    }
}
else {
    console.log('no path provided');
}
